Index: /quintagroup.portlet.cumulus/tags/1.0/README.txt
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/README.txt	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/README.txt	(revision 1047)
@@ -0,0 +1,61 @@
+Introduction
+============
+
+quintagroup.portlet.cumulus is a Plone product that allows you to add tag cloud
+portlets to your Plone site. Your site's tags (content categories are used as 
+tags) are displayed using a Flash movie that rotates them in 3D. It works just 
+like a regular tags cloud, but is more visually exciting. This is the WordPress 
+WP-Cumulus plugin ported to Plone as a portlet.
+
+When you add this portlet anywhere in the site it will display all site's tags. 
+If you have installed QullsEnabled product this portlet will display only blog's 
+tags when rendered inside blog.
+
+Usage
+-----
+
+* Install "Tag cloud (cumulus) portlet" with QuickInstaller.
+
+* Select Tag Cloud (cumulus) portlet from Add portlet drop-down menu.
+
+* Provide your own values for portlet configuration if needed.
+
+* Save changes.
+
+Supported Plone version
+-----------------------
+
+* 3.x
+
+FAQ
+---
+
+From what version of WP-Cumulus WordPress plugin this product was ported?
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+It's ported from WP-Cumulus 1.20.
+
+Some characters are not showing up
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Because of the way Flash handles text, only Latin characters are supported in 
+the current version. This is due to a limitation where in order to be able to 
+animate text fields smoothly the glyphs need to be embedded in the movie. The 
+Flash movie's source code is available for download through Subversion. Doing so 
+will allow you to create a version for your language. There's a text field in 
+the root of the movie that you can use to embed more characters. If you change 
+to another font, you'll need to edit the Tag class as well.
+
+Where can I find more information?
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+WP-Cumulus WordPress plugin homepage: http://wordpress.org/extend/plugins/wp-cumulus/.
+
+Author
+------
+
+* Bohdan Koval
+
+Copyright (c) "Quintagroup": http://quintagroup.com/, 2009.
+
+support@quintagroup.com * quintessence of modern business
Index: /quintagroup.portlet.cumulus/tags/1.0/docs/HISTORY.txt
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/docs/HISTORY.txt	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/docs/HISTORY.txt	(revision 1047)
@@ -0,0 +1,7 @@
+Changelog
+=========
+
+1.0 (2009-04-24)
+----------------
+
+* Initial release
Index: /quintagroup.portlet.cumulus/tags/1.0/docs/INSTALL.txt
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/docs/INSTALL.txt	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/docs/INSTALL.txt	(revision 1047)
@@ -0,0 +1,39 @@
+quintagroup.portlet.cumulus Installation
+=======================
+
+ * When you're reading this you have probably already run
+   ``easy_install quintagroup.portlet.cumulus``. Find out how to install setuptools
+   (and EasyInstall) here:
+   http://peak.telecommunity.com/DevCenter/EasyInstall
+
+ * Create a file called ``quintagroup.portlet.cumulus-configure.zcml`` in the
+   ``/path/to/instance/etc/package-includes`` directory.  The file
+   should only contain this::
+
+       <include package="quintagroup.portlet.cumulus" />
+
+Alternatively, if you are using zc.buildout and the plone.recipe.zope2instance
+recipe to manage your project, you can do this:
+
+ * Add ``quintagroup.portlet.cumulus`` to the list of eggs to install, e.g.:
+
+    [buildout]
+    ...
+    eggs =
+        ...
+        quintagroup.portlet.cumulus
+
+  * Tell the plone.recipe.zope2instance recipe to install a ZCML slug:
+
+    [instance]
+    recipe = plone.recipe.zope2instance
+    ...
+    zcml =
+        quintagroup.portlet.cumulus
+
+  * Re-run buildout, e.g. with:
+
+    $ ./bin/buildout
+
+You can skip the ZCML slug if you are going to explicitly include the package
+from another package's configure.zcml file.
Index: /quintagroup.portlet.cumulus/tags/1.0/docs/LICENSE.GPL
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/docs/LICENSE.GPL	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/docs/LICENSE.GPL	(revision 1047)
@@ -0,0 +1,225 @@
+		    GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term "modification".)  Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+  1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+  2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+
+  4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+  5. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+  6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+
+  8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+  9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+  10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+			    NO WARRANTY
+
+  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+		     END OF TERMS AND CONDITIONS
Index: /quintagroup.portlet.cumulus/tags/1.0/docs/LICENSE.txt
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/docs/LICENSE.txt	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/docs/LICENSE.txt	(revision 1047)
@@ -0,0 +1,16 @@
+  quintagroup.portlet.cumulus is copyright Bohdan Koval
+
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with this program; if not, write to the Free Software
+  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+  MA 02111-1307 USA.
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/__init__.py
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/__init__.py	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/__init__.py	(revision 1047)
@@ -0,0 +1,6 @@
+# See http://peak.telecommunity.com/DevCenter/setuptools#namespace-packages
+try:
+    __import__('pkg_resources').declare_namespace(__name__)
+except ImportError:
+    from pkgutil import extend_path
+    __path__ = extend_path(__path__, __name__)
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/__init__.py
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/__init__.py	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/__init__.py	(revision 1047)
@@ -0,0 +1,6 @@
+# See http://peak.telecommunity.com/DevCenter/setuptools#namespace-packages
+try:
+    __import__('pkg_resources').declare_namespace(__name__)
+except ImportError:
+    from pkgutil import extend_path
+    __path__ = extend_path(__path__, __name__)
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/__init__.py
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/__init__.py	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/__init__.py	(revision 1047)
@@ -0,0 +1,5 @@
+from zope.i18nmessageid import MessageFactory
+CumulusPortletMessageFactory = MessageFactory('quintagroup.portlet.cumulus')
+
+def initialize(context):
+    """Initializer called when used as a Zope 2 product."""
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/blog.py
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/blog.py	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/blog.py	(revision 1047)
@@ -0,0 +1,29 @@
+from zope.interface import implements
+from Products.CMFCore.utils import getToolByName
+
+from quills.core.interfaces import IWeblogLocator
+
+from quintagroup.portlet.cumulus.interfaces import ITagsRetriever
+from quintagroup.portlet.cumulus.catalog import GlobalTags
+
+class QuillsBlogTags(GlobalTags):
+    implements(ITagsRetriever)
+
+    def getTags(self, number=None):
+        """ Get Quills blog's tags.
+        """
+        weblog = self.getWeblog()
+        if weblog == []:
+            return super(QuillsBlogTags, self).getTags(number)
+
+        topics = weblog.getTopics()
+        tags = []
+        for topic in topics:
+            tags.append((topic.getTitle().decode(self.default_charset), len(topic), topic.absolute_url()))
+
+        return tags
+
+    def getWeblog(self):
+        locator = IWeblogLocator(self.context)
+        weblog = locator.find()
+        return weblog
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/catalog.py
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/catalog.py	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/catalog.py	(revision 1047)
@@ -0,0 +1,31 @@
+from zope.interface import implements
+from Products.CMFCore.utils import getToolByName
+
+from quintagroup.portlet.cumulus.interfaces import ITagsRetriever
+
+class GlobalTags(object):
+    implements(ITagsRetriever)
+
+    def __init__(self, context):
+        self.context = context
+        portal_properties = getToolByName(self.context, 'portal_properties')
+        self.default_charset = portal_properties.site_properties.getProperty('default_charset', 'utf-8')
+        portal = getToolByName(context, 'portal_url').getPortalObject()
+        self.portal_url = portal.absolute_url()
+
+    def getTags(self, number=None):
+        """ Entries of 'Categories' archetype field on content are assumed to be tags.
+        """
+        cat = getToolByName(self.context, 'portal_catalog')
+        index = cat._catalog.getIndex('Subject')
+        tags = []
+        for name in index._index.keys():
+            try:
+                number_of_entries = len(index._index[name])
+            except TypeError:
+                number_of_entries = 1
+            name = name.decode(self.default_charset)
+            url = '%s/search?Subject:list=%s' % (self.portal_url, name)
+            tags.append((name, number_of_entries, url))
+
+        return tags
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/configure.zcml
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/configure.zcml	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/configure.zcml	(revision 1047)
@@ -0,0 +1,78 @@
+<configure
+    xmlns="http://namespaces.zope.org/zope"
+    xmlns:five="http://namespaces.zope.org/five"
+    xmlns:i18n="http://namespaces.zope.org/i18n"
+    xmlns:genericsetup="http://namespaces.zope.org/genericsetup"
+    xmlns:plone="http://namespaces.plone.org/plone"
+    xmlns:browser="http://namespaces.zope.org/browser"
+    xmlns:zcml="http://namespaces.zope.org/zcml"
+    i18n_domain="quintagroup.portlet.cumulus">
+
+    <five:registerPackage package="." initialize=".initialize" />
+
+    <i18n:registerTranslations directory="locales" />
+
+    <include package="plone.app.portlets" />
+
+    <genericsetup:registerProfile
+        name="default"
+        title="Tag cloud (cumulus) portlet"
+        directory="profiles/default"
+        description="This package allows you to display your site's tags using a Flash movie that rotates them in 3D. This is a ported to Plone WordPress WP-Cumulus plugin."
+        provides="Products.GenericSetup.interfaces.EXTENSION"
+        />
+
+    <!-- Register the portlet -->
+
+    <plone:portlet
+        name="quintagroup.portlet.cumulus.CumulusPortlet"
+        interface=".cumulusportlet.ICumulusPortlet"
+        assignment=".cumulusportlet.Assignment"
+        view_permission="zope2.View"
+        edit_permission="cmf.ManagePortal"
+        renderer=".cumulusportlet.Renderer"
+        addview=".cumulusportlet.AddForm"
+        editview=".cumulusportlet.EditForm"
+        />
+
+    <browser:resource
+        name="tagcloud.swf"
+        file="tagcloud.swf"
+        />
+
+    <browser:resource
+        name="swfobject.js"
+        file="swfobject.js"
+        />
+
+    <!-- Register tags retriever adapters -->
+    <!-- default tags retriever that works everywhere -->
+    <adapter
+        for="*"
+        provides=".interfaces.ITagsRetriever"
+        factory=".catalog.GlobalTags"
+        />
+
+    <configure zcml:condition="installed quills.core">
+        <!-- tags retrievers for Quills blog -->
+        <adapter
+            for="quills.core.interfaces.IBaseContent"
+            provides=".interfaces.ITagsRetriever"
+            factory=".blog.QuillsBlogTags"
+            />
+
+        <adapter
+            for="quills.core.interfaces.IWeblogEnhanced"
+            provides=".interfaces.ITagsRetriever"
+            factory=".blog.QuillsBlogTags"
+            />
+
+        <adapter
+            for="quills.core.interfaces.IPossibleWeblogEntry"
+            provides=".interfaces.ITagsRetriever"
+            factory=".blog.QuillsBlogTags"
+            />
+
+    </configure>
+
+</configure>
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/cumulusportlet.pt
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/cumulusportlet.pt	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/cumulusportlet.pt	(revision 1047)
@@ -0,0 +1,55 @@
+<dl class="portlet portletCumulusPortlet"
+    i18n:domain="quintagroup.portlet.cumulus">
+
+    <dt class="portletHeader">
+        <span class="portletTopLeft"></span>
+        <span tal:replace="view/title"></span>
+        <span class="portletTopRight"></span>
+    </dt>
+
+    <dd class="portletItem odd" style="padding: 0;">
+        <tal:block condition="not:view/compmode">
+            <script type="text/javascript" src="swfobject.js"
+                tal:attributes="src string:${view/portal_url}/++resource++swfobject.js">
+            </script>
+            <div id="comulus">
+                <p style="display:none;" tal:content="structure view/getTagAnchors">
+                </p>
+                <p style="padding: 1em; margin-bottom: 0;">
+                    WP Cumulus Flash tag cloud by <a href="http://www.roytanck.com">Roy Tanck</a>
+                    requires Flash Player 9 or better.
+                </p>
+            </div>
+            <script type="text/javascript" tal:replace="structure view/getScript">
+            </script>
+        </tal:block>
+
+        <tal:block condition="view/compmode" tal:define="params view/getParams">
+            <object type="application/x-shockwave-flash" data="tagcloud.swf" width="" height=""
+                    tal:attributes="data params/url;
+                                    width params/width;
+                                    height params/height">
+                <param name="movie" value="tagcloud.swf"
+                    tal:attributes="value params/url" />
+                <param name="bgcolor" value=""
+                    tal:attributes="value params/bgcolor" />
+                <param name="AllowScriptAccess" value="always">
+                <param name="wmode" value="transparent"
+                    tal:condition="params/trans" />
+                <param name="flashvars" value=""
+                    tal:attributes="value params/flashvars;"/>
+                <p style="padding: 1em;" tal:content="structure view/getTagAnchors"></p>
+                <p style="padding: 1em; margin-bottom: 0;">
+                    WP-Cumulus by <a href="http://www.roytanck.com/">Roy Tanck</a>
+                    requires Flash Player 9 or better.
+                </p>
+            </object>
+        </tal:block>
+    </dd>
+
+    <dd class="portletFooter">
+        <span class="portletBottomLeft"></span>
+        <span class="portletBottomRight"></span>
+    </dd>
+
+</dl>
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/cumulusportlet.py
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/cumulusportlet.py	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/cumulusportlet.py	(revision 1047)
@@ -0,0 +1,247 @@
+import urllib
+
+from zope.interface import implements
+from zope.component import getMultiAdapter
+from zope.component import getAdapter
+
+from plone.portlets.interfaces import IPortletDataProvider
+from plone.app.portlets.portlets import base
+from plone.memoize.instance import memoize
+
+from zope import schema
+from zope.formlib import form
+from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile
+
+from quintagroup.portlet.cumulus import CumulusPortletMessageFactory as _
+from quintagroup.portlet.cumulus.interfaces import ITagsRetriever
+
+class ICumulusPortlet(IPortletDataProvider):
+    """ A cumulus tag cloud portlet.
+    """
+    # options for generating <embed ... /> tag
+    width = schema.Int(
+        title=_(u'Width of the Flash tag cloud'),
+        description=_(u'Width in pixels (500 or more is recommended).'),
+        required=True,
+        default=152)
+
+    height = schema.Int(
+        title=_(u'Height of the Flash tag cloud'),
+        description=_(u'Height in pixels (ideally around 3/4 of the width).'),
+        required=True,
+        default=152)
+
+    tcolor = schema.TextLine(
+        title=_(u'Color of the tags'),
+        description=_(u'This and next 3 fields should be 6 character hex color values without the # prefix (000000 for black, ffffff for white).'),
+        required=True,
+        default=u'5391d0')
+
+    tcolor2 = schema.TextLine(
+        title=_(u'Optional second color for gradient'),
+        description=_(u'When this color is available, each tag\'s color will be from a gradient between the two. This allows you to create a multi-colored tag cloud.'),
+        required=False,
+        default=u'333333')
+
+    hicolor = schema.TextLine(
+        title=_(u'Optional highlight color'),
+        description=_(u'Color of the tag when mouse is over it.'),
+        required=False,
+        default=u'578308')
+
+    bgcolor = schema.TextLine(
+        title=_(u'Background color'),
+        description=_(u'The hex value for the background color you\'d like to use. This options has no effect when \'Use transparent mode\' is selected.'),
+        required=True,
+        default=u'ffffff')
+
+    trans = schema.Bool(
+        title=_(u'Use transparent mode'),
+        description=_(u'Switches on Flash\'s wmode-transparent setting.'),
+        required=True,
+        default=False)
+
+    speed = schema.Int(
+        title=_(u'Rotation speed'),
+        description=_(u'Speed of the sphere. Options between 25 and 500 work best.'),
+        required=True,
+        default=100)
+
+    distr = schema.Bool(
+        title=_(u'Distribute tags evenly on sphere'),
+        description=_(u'When enabled, the movie will attempt to distribute the tags evenly over the surface of the sphere.'),
+        required=True,
+        default=True)
+
+    compmode = schema.Bool(
+        title=_(u'Use compatibility mode?'),
+        description=_(u'Enabling this option switches the plugin to a different way of embedding Flash into the page. Use this if your page has markup errors or if you\'re having trouble getting tag cloud to display correctly.'),
+        required=True,
+        default=False)
+
+    # options for generating tag cloud data
+    smallest = schema.Int(
+        title=_(u'Smallest tag size'),
+        description=_(u'The text size of the tag with the smallest count value (units given by unit parameter).'),
+        required=True,
+        default=8)
+
+    largest = schema.Int(
+        title=_(u'Largest tag size'),
+        description=_(u'The text size of the tag with the highest count value (units given by the unit parameter).'),
+        required=True,
+        default=22)
+
+    unit = schema.TextLine(
+        title=_(u'Unit of measure'),
+        description=_(u'Unit of measure as pertains to the smallest and largest values. This can be any CSS length value, e.g. pt, px, em, %.'),
+        required=True,
+        default=u'pt')
+
+class Assignment(base.Assignment):
+    """Portlet assignment.
+
+    This is what is actually managed through the portlets UI and associated
+    with columns.
+    """
+
+    implements(ICumulusPortlet)
+
+    width    = 152;
+    height   = 152;
+    tcolor   = u'5391d0'
+    tcolor2  = u'333333'
+    hicolor  = u'578308'
+    bgcolor  = u'ffffff'
+    speed    = 100
+    trans    = False
+    distr    = True
+    compmode = False
+
+    smallest = 8
+    largest  = 22
+    unit     = u'pt'
+
+    def __init__(self, **kw):
+        for k, v in kw.items():
+            setattr(self, k, v)
+
+    @property
+    def title(self):
+        """This property is used to give the title of the portlet in the
+        "manage portlets" screen.
+        """
+        return _("Tag Cloud (cumulus)")
+
+
+class Renderer(base.Renderer):
+    """Portlet renderer.
+    """
+
+    render = ViewPageTemplateFile('cumulusportlet.pt')
+
+    def __init__(self, context, request, view, manager, data):
+        base.Renderer.__init__(self, context, request, view, manager, data)
+        portal_state = getMultiAdapter((context, request), name=u'plone_portal_state')
+        self.portal_url = portal_state.portal_url()
+        portal_properties = getMultiAdapter((context, request), name=u'plone_tools').properties()
+        self.default_charset = portal_properties.site_properties.getProperty('default_charset', 'utf-8')
+
+    @property
+    def title(self):
+        return _("Tag Cloud")
+
+    @property
+    def compmode(self):
+        return self.data.compmode
+
+    def getScript(self):
+        params = self.getParams()
+        return """<script type="text/javascript">
+                var so = new SWFObject("%(url)s", "tagcloudflash", "%(width)s", "%(height)s", "9", "#%(bgcolor)s");
+                %(trans)s
+                so.addParam("allowScriptAccess", "always");
+                so.addVariable("tcolor", "0x%(tcolor)s");
+                so.addVariable("tcolor2", "0x%(tcolor2)s");
+                so.addVariable("hicolor", "0x%(hicolor)s");
+                so.addVariable("tspeed", "%(tspeed)s");
+                so.addVariable("distr", "%(distr)s");
+                so.addVariable("mode", "%(mode)s");
+                so.addVariable("tagcloud", "%(tagcloud)s");
+                so.write("comulus");
+            </script>""" % params
+
+    def getParams(self):
+        tagcloud = '<tags>%s</tags>' % self.getTagAnchors()
+        tagcloud = tagcloud.encode(self.default_charset)
+        tagcloud = urllib.quote(tagcloud)
+        params = {
+            'url': self.portal_url + '/++resource++tagcloud.swf',
+            'width': self.data.width,
+            'height': self.data.height,
+            'bgcolor': self.data.bgcolor,
+            'trans': self.data.trans and 'so.addParam("wmode", "transparent");' or '',
+            'tcolor': self.data.tcolor,
+            'tcolor2': self.data.tcolor2 or self.data.tcolor,
+            'hicolor': self.data.hicolor or self.data.tcolor,
+            'tspeed': self.data.speed,
+            'distr': self.data.distr and 'true' or 'false',
+            'mode': 'tags',
+            'tagcloud': tagcloud,
+        }
+        flashvars = []
+        for var in ('tcolor', 'tcolor2', 'hicolor', 'tspeed', 'distr', 'mode', 'tagcloud'):
+            flashvars.append('%s=%s' % (var, params[var]))
+        params['flashvars'] = '&'.join(flashvars)
+        return params
+
+    @memoize
+    def getTagAnchors(self):
+        tags = ''
+        for tag in self.getTags():
+            tags += '<a href="%s" title="%s entries" rel="tag" style="font-size: %.1f%s;">%s</a>\n' % \
+                (tag['url'], tag['number_of_entries'], tag['size'], self.data.unit, tag['name'])
+        return tags
+
+    def getTags(self):
+        tags = ITagsRetriever(self.context).getTags()
+        if tags == []:
+            return []
+
+        number_of_entries = [i[1] for i in tags]
+
+        min_number = min(number_of_entries)
+        max_number = max(number_of_entries)
+        distance = float(max_number - min_number) or 1
+        step = (self.data.largest - self.data.smallest) / distance
+
+        result = []
+        for name, number, url in tags:
+            size = self.data.smallest + step * (number - min_number)
+            result.append({
+                'name': name,
+                'size': size,
+                'number_of_entries': number,
+                'url': url
+            })
+        return result
+
+class AddForm(base.AddForm):
+    """Portlet add form.
+
+    This is registered in configure.zcml. The form_fields variable tells
+    zope.formlib which fields to display. The create() method actually
+    constructs the assignment that is being added.
+    """
+    form_fields = form.Fields(ICumulusPortlet)
+
+    def create(self, data):
+        return Assignment(**data)
+
+class EditForm(base.EditForm):
+    """Portlet edit form.
+
+    This is registered with configure.zcml. The form_fields variable tells
+    zope.formlib which fields to display.
+    """
+    form_fields = form.Fields(ICumulusPortlet)
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/interfaces.py
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/interfaces.py	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/interfaces.py	(revision 1047)
@@ -0,0 +1,9 @@
+from zope.interface import Interface
+
+class ITagsRetriever(Interface):
+
+    def getTags(number=None):
+        """ Get list of (tag, number_or_entries, url) tuples.
+
+            number - the number of actual tags to return (all tags if omitted)
+        """
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/locales/quintagroup.portlet.cumulus.pot
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/locales/quintagroup.portlet.cumulus.pot	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/locales/quintagroup.portlet.cumulus.pot	(revision 1047)
@@ -0,0 +1,130 @@
+# Translation template for quintagroup.portlet.cumulus package.
+# Bohdan Koval <koval@quintagroup.com>, 2009.
+msgid ""
+msgstr ""
+"Project-Id-Version: quintagroup.portlet.cumulus 1.0\n"
+"POT-Creation-Date: 2009-04-22 14:14+0000\n"
+"PO-Revision-Date: YEAR-MO-DA HO:MI +ZONE\n"
+"Last-Translator: Bohdan Koval <koval@quintagroup.com>\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=utf-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=1; plural=0\n"
+"Language-Code: en\n"
+"Language-Name: English\n"
+"Preferred-Encodings: utf-8 latin1\n"
+"Domain: quintagroup.portlet.cumulus\n"
+
+#: ./cumulusportlet.py:53
+msgid "Background color"
+msgstr ""
+
+#: ./cumulusportlet.py:48
+msgid "Color of the tag when mouse is over it."
+msgstr ""
+
+#: ./cumulusportlet.py:35
+msgid "Color of the tags"
+msgstr ""
+
+#: ./cumulusportlet.py:71
+msgid "Distribute tags evenly on sphere"
+msgstr ""
+
+#: ./cumulusportlet.py:78
+msgid "Enabling this option switches the plugin to a different way of embedding Flash into the page. Use this if your page has markup errors or if you're having trouble getting tag cloud to display correctly."
+msgstr ""
+
+#: ./cumulusportlet.py:30
+msgid "Height in pixels (ideally around 3/4 of the width)."
+msgstr ""
+
+#: ./cumulusportlet.py:29
+msgid "Height of the Flash tag cloud"
+msgstr ""
+
+#: ./cumulusportlet.py:90
+msgid "Largest tag size"
+msgstr ""
+
+#: ./cumulusportlet.py:47
+msgid "Optional highlight color"
+msgstr ""
+
+#: ./cumulusportlet.py:41
+msgid "Optional second color for gradient"
+msgstr ""
+
+#: ./cumulusportlet.py:65
+msgid "Rotation speed"
+msgstr ""
+
+#: ./cumulusportlet.py:84
+msgid "Smallest tag size"
+msgstr ""
+
+#: ./cumulusportlet.py:66
+msgid "Speed of the sphere. Options between 25 and 500 work best."
+msgstr ""
+
+#: ./cumulusportlet.py:60
+msgid "Switches on Flash's wmode-transparent setting."
+msgstr ""
+
+#: ./cumulusportlet.py:152
+msgid "Tag Cloud"
+msgstr ""
+
+#: ./cumulusportlet.py:134
+msgid "Tag Cloud (cumulus)"
+msgstr ""
+
+#: ./cumulusportlet.py:54
+msgid "The hex value for the background color you'd like to use. This options has no effect when 'Use transparent mode' is selected."
+msgstr ""
+
+#: ./cumulusportlet.py:91
+msgid "The text size of the tag with the highest count value (units given by the unit parameter)."
+msgstr ""
+
+#: ./cumulusportlet.py:85
+msgid "The text size of the tag with the smallest count value (units given by unit parameter)."
+msgstr ""
+
+#: ./cumulusportlet.py:36
+msgid "This and next 3 fields should be 6 character hex color values without the # prefix (000000 for black, ffffff for white)."
+msgstr ""
+
+#: ./cumulusportlet.py:96
+msgid "Unit of measure"
+msgstr ""
+
+#: ./cumulusportlet.py:97
+msgid "Unit of measure as pertains to the smallest and largest values. This can be any CSS length value, e.g. pt, px, em, %."
+msgstr ""
+
+#: ./cumulusportlet.py:77
+msgid "Use compatibility mode?"
+msgstr ""
+
+#: ./cumulusportlet.py:59
+msgid "Use transparent mode"
+msgstr ""
+
+#: ./cumulusportlet.py:72
+msgid "When enabled, the movie will attempt to distribute the tags evenly over the surface of the sphere."
+msgstr ""
+
+#: ./cumulusportlet.py:42
+msgid "When this color is available, each tag's color will be from a gradient between the two. This allows you to create a multi-colored tag cloud."
+msgstr ""
+
+#: ./cumulusportlet.py:24
+msgid "Width in pixels (500 or more is recommended)."
+msgstr ""
+
+#: ./cumulusportlet.py:23
+msgid "Width of the Flash tag cloud"
+msgstr ""
+
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/profiles/default/metadata.xml
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/profiles/default/metadata.xml	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/profiles/default/metadata.xml	(revision 1047)
@@ -0,0 +1,4 @@
+<?xml version="1.0"?>
+<metadata>
+  <version>1.0</version>
+</metadata>
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/profiles/default/portlets.xml
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/profiles/default/portlets.xml	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/profiles/default/portlets.xml	(revision 1047)
@@ -0,0 +1,12 @@
+<?xml version="1.0"?>
+<portlets>
+
+ <!-- Portlet type registrations -->
+
+ <portlet
+   addview="quintagroup.portlet.cumulus.CumulusPortlet"
+   title="Tag Cloud (cumulus)"
+   description="This portlet displays a tag cloud using a Flash movie that rotates tags in 3D."
+   />
+
+</portlets>
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/swfobject.js
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/swfobject.js	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/swfobject.js	(revision 1047)
@@ -0,0 +1,133 @@
+/**
+ * SWFObject v1.4: Flash Player detection and embed - http://blog.deconcept.com/swfobject/
+ *
+ * SWFObject is (c) 2006 Geoff Stearns and is released under the MIT License:
+ * http://www.opensource.org/licenses/mit-license.php
+ *
+ * **SWFObject is the SWF embed script formarly known as FlashObject. The name was changed for
+ *   legal reasons.
+ */
+if(typeof deconcept=="undefined"){var deconcept=new Object();}
+if(typeof deconcept.util=="undefined"){deconcept.util=new Object();}
+if(typeof deconcept.SWFObjectUtil=="undefined"){deconcept.SWFObjectUtil=new Object();}
+deconcept.SWFObject=function(_1,id,w,h,_5,c,_7,_8,_9,_a,_b){
+if(!document.createElement||!document.getElementById){return;}
+this.DETECT_KEY=_b?_b:"detectflash";
+this.skipDetect=deconcept.util.getRequestParameter(this.DETECT_KEY);
+this.params=new Object();
+this.variables=new Object();
+this.attributes=new Array();
+if(_1){this.setAttribute("swf",_1);}
+if(id){this.setAttribute("id",id);}
+if(w){this.setAttribute("width",w);}
+if(h){this.setAttribute("height",h);}
+if(_5){this.setAttribute("version",new deconcept.PlayerVersion(_5.toString().split(".")));}
+this.installedVer=deconcept.SWFObjectUtil.getPlayerVersion(this.getAttribute("version"),_7);
+if(c){this.addParam("bgcolor",c);}
+var q=_8?_8:"high";
+this.addParam("quality",q);
+this.setAttribute("useExpressInstall",_7);
+this.setAttribute("doExpressInstall",false);
+var _d=(_9)?_9:window.location;
+this.setAttribute("xiRedirectUrl",_d);
+this.setAttribute("redirectUrl","");
+if(_a){this.setAttribute("redirectUrl",_a);}};
+deconcept.SWFObject.prototype={setAttribute:function(_e,_f){
+this.attributes[_e]=_f;
+},getAttribute:function(_10){
+return this.attributes[_10];
+},addParam:function(_11,_12){
+this.params[_11]=_12;
+},getParams:function(){
+return this.params;
+},addVariable:function(_13,_14){
+this.variables[_13]=_14;
+},getVariable:function(_15){
+return this.variables[_15];
+},getVariables:function(){
+return this.variables;
+},getVariablePairs:function(){
+var _16=new Array();
+var key;
+var _18=this.getVariables();
+for(key in _18){
+_16.push(key+"="+_18[key]);}
+return _16;
+},getSWFHTML:function(){
+var _19="";
+if(navigator.plugins&&navigator.mimeTypes&&navigator.mimeTypes.length){
+if(this.getAttribute("doExpressInstall")){this.addVariable("MMplayerType","PlugIn");}
+_19="<embed type=\"application/x-shockwave-flash\" src=\""+this.getAttribute("swf")+"\" width=\""+this.getAttribute("width")+"\" height=\""+this.getAttribute("height")+"\"";
+_19+=" id=\""+this.getAttribute("id")+"\" name=\""+this.getAttribute("id")+"\" ";
+var _1a=this.getParams();
+for(var key in _1a){_19+=[key]+"=\""+_1a[key]+"\" ";}
+var _1c=this.getVariablePairs().join("&");
+if(_1c.length>0){_19+="flashvars=\""+_1c+"\"";}
+_19+="/>";
+}else{
+if(this.getAttribute("doExpressInstall")){this.addVariable("MMplayerType","ActiveX");}
+_19="<object id=\""+this.getAttribute("id")+"\" classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" width=\""+this.getAttribute("width")+"\" height=\""+this.getAttribute("height")+"\">";
+_19+="<param name=\"movie\" value=\""+this.getAttribute("swf")+"\" />";
+var _1d=this.getParams();
+for(var key in _1d){_19+="<param name=\""+key+"\" value=\""+_1d[key]+"\" />";}
+var _1f=this.getVariablePairs().join("&");
+if(_1f.length>0){_19+="<param name=\"flashvars\" value=\""+_1f+"\" />";}
+_19+="</object>";}
+return _19;
+},write:function(_20){
+if(this.getAttribute("useExpressInstall")){
+var _21=new deconcept.PlayerVersion([6,0,65]);
+if(this.installedVer.versionIsValid(_21)&&!this.installedVer.versionIsValid(this.getAttribute("version"))){
+this.setAttribute("doExpressInstall",true);
+this.addVariable("MMredirectURL",escape(this.getAttribute("xiRedirectUrl")));
+document.title=document.title.slice(0,47)+" - Flash Player Installation";
+this.addVariable("MMdoctitle",document.title);}}
+if(this.skipDetect||this.getAttribute("doExpressInstall")||this.installedVer.versionIsValid(this.getAttribute("version"))){
+var n=(typeof _20=="string")?document.getElementById(_20):_20;
+n.innerHTML=this.getSWFHTML();
+return true;
+}else{
+if(this.getAttribute("redirectUrl")!=""){document.location.replace(this.getAttribute("redirectUrl"));}}
+return false;}};
+deconcept.SWFObjectUtil.getPlayerVersion=function(_23,_24){
+var _25=new deconcept.PlayerVersion([0,0,0]);
+if(navigator.plugins&&navigator.mimeTypes.length){
+var x=navigator.plugins["Shockwave Flash"];
+if(x&&x.description){_25=new deconcept.PlayerVersion(x.description.replace(/([a-z]|[A-Z]|\s)+/,"").replace(/(\s+r|\s+b[0-9]+)/,".").split("."));}
+}else{try{
+var axo=new ActiveXObject("ShockwaveFlash.ShockwaveFlash");
+for(var i=3;axo!=null;i++){
+axo=new ActiveXObject("ShockwaveFlash.ShockwaveFlash."+i);
+_25=new deconcept.PlayerVersion([i,0,0]);}}
+catch(e){}
+if(_23&&_25.major>_23.major){return _25;}
+if(!_23||((_23.minor!=0||_23.rev!=0)&&_25.major==_23.major)||_25.major!=6||_24){
+try{_25=new deconcept.PlayerVersion(axo.GetVariable("$version").split(" ")[1].split(","));}
+catch(e){}}}
+return _25;};
+deconcept.PlayerVersion=function(_29){
+this.major=parseInt(_29[0])!=null?parseInt(_29[0]):0;
+this.minor=parseInt(_29[1])||0;
+this.rev=parseInt(_29[2])||0;};
+deconcept.PlayerVersion.prototype.versionIsValid=function(fv){
+if(this.major<fv.major){return false;}
+if(this.major>fv.major){return true;}
+if(this.minor<fv.minor){return false;}
+if(this.minor>fv.minor){return true;}
+if(this.rev<fv.rev){return false;}return true;};
+deconcept.util={getRequestParameter:function(_2b){
+var q=document.location.search||document.location.hash;
+if(q){
+var _2d=q.indexOf(_2b+"=");
+var _2e=(q.indexOf("&",_2d)>-1)?q.indexOf("&",_2d):q.length;
+if(q.length>1&&_2d>-1){
+return q.substring(q.indexOf("=",_2d)+1,_2e);
+}}return "";}};
+if(Array.prototype.push==null){
+Array.prototype.push=function(_2f){
+this[this.length]=_2f;
+return this.length;};}
+var getQueryParamValue=deconcept.util.getRequestParameter;
+var FlashObject=deconcept.SWFObject; // for backwards compatibility
+var SWFObject=deconcept.SWFObject;
+
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/tests/__init__.py
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/tests/__init__.py	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/tests/__init__.py	(revision 1047)
@@ -0,0 +1,1 @@
+#
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/tests/base.py
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/tests/base.py	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/tests/base.py	(revision 1047)
@@ -0,0 +1,53 @@
+from Products.Five import zcml
+from Products.Five import fiveconfigure
+
+from Testing import ZopeTestCase as ztc
+
+from Products.PloneTestCase import PloneTestCase as ptc
+from Products.PloneTestCase.layer import onsetup
+
+try:
+    import Products.QuillsEnabled
+    HAS_QUILLS_ENABLED = True
+except ImportError:
+    HAS_QUILLS_ENABLED = False
+
+@onsetup
+def setup_product():
+    """Set up additional products and ZCML required to test this product.
+
+    The @onsetup decorator causes the execution of this body to be deferred
+    until the setup of the Plone site testing layer.
+    """
+
+    # Load the ZCML configuration for this package and its dependencies
+
+    fiveconfigure.debug_mode = True
+    import quintagroup.portlet.cumulus
+    zcml.load_config('configure.zcml', quintagroup.portlet.cumulus)
+    fiveconfigure.debug_mode = False
+
+    # We need to tell the testing framework that these products
+    # should be available. This can't happen until after we have loaded
+    # the ZCML.
+
+    ztc.installPackage('quintagroup.portlet.cumulus')
+    if HAS_QUILLS_ENABLED:
+        ztc.installProduct('QuillsEnabled')
+
+# The order here is important: We first call the deferred function and then
+# let PloneTestCase install it during Plone site setup
+
+setup_product()
+prods = ['quintagroup.portlet.cumulus']
+if HAS_QUILLS_ENABLED:
+    prods.append('QuillsEnabled')
+ptc.setupPloneSite(products=prods)
+
+class TestCase(ptc.PloneTestCase):
+    """Base class used for test cases
+    """
+
+class FunctionalTestCase(ptc.FunctionalTestCase):
+    """Test case class used for functional (doc-)tests
+    """
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/tests/test_portlet.py
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/tests/test_portlet.py	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/tests/test_portlet.py	(revision 1047)
@@ -0,0 +1,171 @@
+from zope.interface import alsoProvides
+from zope.component import getUtility, getMultiAdapter
+
+from plone.portlets.interfaces import IPortletType
+from plone.portlets.interfaces import IPortletManager
+from plone.portlets.interfaces import IPortletAssignment
+from plone.portlets.interfaces import IPortletDataProvider
+from plone.portlets.interfaces import IPortletRenderer
+
+from plone.app.portlets.storage import PortletAssignmentMapping
+
+from quintagroup.portlet.cumulus import cumulusportlet
+
+from quintagroup.portlet.cumulus.tests.base import TestCase, HAS_QUILLS_ENABLED
+
+class TestPortlet(TestCase):
+
+    def afterSetUp(self):
+        self.setRoles(('Manager', ))
+
+    def test_portlet_type_registered(self):
+        portlet = getUtility(
+            IPortletType,
+            name='quintagroup.portlet.cumulus.CumulusPortlet')
+        self.assertEquals(portlet.addview,
+                          'quintagroup.portlet.cumulus.CumulusPortlet')
+
+    def test_interfaces(self):
+        portlet = cumulusportlet.Assignment()
+        self.failUnless(IPortletAssignment.providedBy(portlet))
+        self.failUnless(IPortletDataProvider.providedBy(portlet.data))
+
+    def test_invoke_add_view(self):
+        portlet = getUtility(
+            IPortletType,
+            name='quintagroup.portlet.cumulus.CumulusPortlet')
+        mapping = self.portal.restrictedTraverse(
+            '++contextportlets++plone.leftcolumn')
+        for m in mapping.keys():
+            del mapping[m]
+        addview = mapping.restrictedTraverse('+/' + portlet.addview)
+        addview.createAndAdd(data={})
+
+        self.assertEquals(len(mapping), 1)
+        self.failUnless(isinstance(mapping.values()[0],
+                                   cumulusportlet.Assignment))
+
+    def test_invoke_edit_view(self):
+        mapping = PortletAssignmentMapping()
+        request = self.folder.REQUEST
+
+        mapping['foo'] = cumulusportlet.Assignment()
+        editview = getMultiAdapter((mapping['foo'], request), name='edit')
+        self.failUnless(isinstance(editview, cumulusportlet.EditForm))
+
+    def test_obtain_renderer(self):
+        context = self.folder
+        request = self.folder.REQUEST
+        view = self.folder.restrictedTraverse('@@plone')
+        manager = getUtility(IPortletManager, name='plone.rightcolumn',
+                             context=self.portal)
+
+        assignment = cumulusportlet.Assignment()
+
+        renderer = getMultiAdapter(
+            (context, request, view, manager, assignment), IPortletRenderer)
+        self.failUnless(isinstance(renderer, cumulusportlet.Renderer))
+
+
+class TestRenderer(TestCase):
+
+    def afterSetUp(self):
+        self.setRoles(('Manager', ))
+        self.portal['front-page'].edit(subject=['global', 'tags'])
+        id_ = self.folder.invokeFactory('Document', id='blog-entry')
+        self.folder[id_].edit(subject=['blog', 'tags'])
+        if HAS_QUILLS_ENABLED:
+            from quills.core.interfaces import IWeblogEnhanced
+            alsoProvides(self.folder, IWeblogEnhanced)
+            self.folder.reindexObject()
+
+    def renderer(self, context=None, request=None, view=None, manager=None,
+                 assignment=None):
+        context = context or self.folder
+        request = request or self.folder.REQUEST
+        view = view or self.folder.restrictedTraverse('@@plone')
+        manager = manager or getUtility(
+            IPortletManager, name='plone.rightcolumn', context=self.portal)
+
+        assignment = assignment or cumulusportlet.Assignment()
+        return getMultiAdapter((context, request, view, manager, assignment),
+                               IPortletRenderer)
+
+    def test_render_default(self):
+        r = self.renderer(context=self.portal,
+                          assignment=cumulusportlet.Assignment())
+        r = r.__of__(self.folder)
+        r.update()
+        output = r.render()
+        expected = """<script type="text/javascript"
+                    src="http://nohost/plone/++resource++swfobject.js">
+            </script>
+            <div id="comulus">
+                <p style="display:none;"><a href="http://nohost/plone/search?Subject:list=blog" title="1 entries" rel="tag" style="font-size: 8.0pt;">blog</a>
+<a href="http://nohost/plone/search?Subject:list=global" title="1 entries" rel="tag" style="font-size: 8.0pt;">global</a>
+<a href="http://nohost/plone/search?Subject:list=tags" title="2 entries" rel="tag" style="font-size: 22.0pt;">tags</a>
+</p>
+                <p style="padding: 1em; margin-bottom: 0;">
+                    WP Cumulus Flash tag cloud by <a href="http://www.roytanck.com">Roy Tanck</a>
+                    requires Flash Player 9 or better.
+                </p>
+            </div>
+            <script type="text/javascript">
+                var so = new SWFObject("http://nohost/plone/++resource++tagcloud.swf", "tagcloudflash", "152", "152", "9", "#ffffff");
+                
+                so.addParam("allowScriptAccess", "always");
+                so.addVariable("tcolor", "0x5391d0");
+                so.addVariable("tcolor2", "0x333333");
+                so.addVariable("hicolor", "0x578308");
+                so.addVariable("tspeed", "100");
+                so.addVariable("distr", "true");
+                so.addVariable("mode", "tags");
+                so.addVariable("tagcloud", "%3Ctags%3E%3Ca%20href%3D%22http%3A//nohost/plone/search%3FSubject%3Alist%3Dblog%22%20title%3D%221%20entries%22%20rel%3D%22tag%22%20style%3D%22font-size%3A%208.0pt%3B%22%3Eblog%3C/a%3E%0A%3Ca%20href%3D%22http%3A//nohost/plone/search%3FSubject%3Alist%3Dglobal%22%20title%3D%221%20entries%22%20rel%3D%22tag%22%20style%3D%22font-size%3A%208.0pt%3B%22%3Eglobal%3C/a%3E%0A%3Ca%20href%3D%22http%3A//nohost/plone/search%3FSubject%3Alist%3Dtags%22%20title%3D%222%20entries%22%20rel%3D%22tag%22%20style%3D%22font-size%3A%2022.0pt%3B%22%3Etags%3C/a%3E%0A%3C/tags%3E");
+                so.write("comulus");
+            </script>"""
+        self.failUnless(expected in output, 'Bad output')
+
+    def test_render_compmode(self):
+        r = self.renderer(context=self.portal,
+                          assignment=cumulusportlet.Assignment(compmode=True, width=200, height=200))
+        r = r.__of__(self.folder)
+        r.update()
+        output = r.render()
+        expected = """<object type="application/x-shockwave-flash"
+                    data="http://nohost/plone/++resource++tagcloud.swf"
+                    width="200" height="200">
+                <param name="movie"
+                       value="http://nohost/plone/++resource++tagcloud.swf" />
+                <param name="bgcolor" value="ffffff" />
+                <param name="AllowScriptAccess" value="always">
+                
+                <param name="flashvars"
+                       value="tcolor=5391d0&amp;tcolor2=333333&amp;hicolor=578308&amp;tspeed=100&amp;distr=true&amp;mode=tags&amp;tagcloud=%3Ctags%3E%3Ca%20href%3D%22http%3A//nohost/plone/search%3FSubject%3Alist%3Dblog%22%20title%3D%221%20entries%22%20rel%3D%22tag%22%20style%3D%22font-size%3A%208.0pt%3B%22%3Eblog%3C/a%3E%0A%3Ca%20href%3D%22http%3A//nohost/plone/search%3FSubject%3Alist%3Dglobal%22%20title%3D%221%20entries%22%20rel%3D%22tag%22%20style%3D%22font-size%3A%208.0pt%3B%22%3Eglobal%3C/a%3E%0A%3Ca%20href%3D%22http%3A//nohost/plone/search%3FSubject%3Alist%3Dtags%22%20title%3D%222%20entries%22%20rel%3D%22tag%22%20style%3D%22font-size%3A%2022.0pt%3B%22%3Etags%3C/a%3E%0A%3C/tags%3E" />
+                <p style="padding: 1em;"><a href="http://nohost/plone/search?Subject:list=blog" title="1 entries" rel="tag" style="font-size: 8.0pt;">blog</a>
+<a href="http://nohost/plone/search?Subject:list=global" title="1 entries" rel="tag" style="font-size: 8.0pt;">global</a>
+<a href="http://nohost/plone/search?Subject:list=tags" title="2 entries" rel="tag" style="font-size: 22.0pt;">tags</a>
+</p>
+                <p style="padding: 1em; margin-bottom: 0;">
+                    WP-Cumulus by <a href="http://www.roytanck.com/">Roy Tanck</a>
+                    requires Flash Player 9 or better.
+                </p>
+            </object>"""
+        self.failUnless(expected in output, 'Bad output')
+
+    if HAS_QUILLS_ENABLED:
+        def test_render_on_blog(self):
+            r = self.renderer(context=self.folder,
+                            assignment=cumulusportlet.Assignment(compmode=True, width=200, height=200))
+            r = r.__of__(self.folder)
+            r.update()
+            output = r.render()
+            expected = """<param name="flashvars"
+                       value="tcolor=5391d0&amp;tcolor2=333333&amp;hicolor=578308&amp;tspeed=100&amp;distr=true&amp;mode=tags&amp;tagcloud=%3Ctags%3E%3Ca%20href%3D%22http%3A//nohost/plone/Members/test_user_1_/topics/blog%22%20title%3D%220%20entries%22%20rel%3D%22tag%22%20style%3D%22font-size%3A%208.0pt%3B%22%3Eblog%3C/a%3E%0A%3Ca%20href%3D%22http%3A//nohost/plone/Members/test_user_1_/topics/tags%22%20title%3D%220%20entries%22%20rel%3D%22tag%22%20style%3D%22font-size%3A%208.0pt%3B%22%3Etags%3C/a%3E%0A%3C/tags%3E" />"""
+            self.failUnless(expected in output, 'Bad output')
+
+def test_suite():
+    from unittest import TestSuite, makeSuite
+    suite = TestSuite()
+    suite.addTest(makeSuite(TestPortlet))
+    suite.addTest(makeSuite(TestRenderer))
+    return suite
Index: /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/version.txt
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/version.txt	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/quintagroup/portlet/cumulus/version.txt	(revision 1047)
@@ -0,0 +1,1 @@
+1.0
Index: /quintagroup.portlet.cumulus/tags/1.0/setup.cfg
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/setup.cfg	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/setup.cfg	(revision 1047)
@@ -0,0 +1,3 @@
+[egg_info]
+tag_build = dev
+tag_svn_revision = true
Index: /quintagroup.portlet.cumulus/tags/1.0/setup.py
===================================================================
--- /quintagroup.portlet.cumulus/tags/1.0/setup.py	(revision 1047)
+++ /quintagroup.portlet.cumulus/tags/1.0/setup.py	(revision 1047)
@@ -0,0 +1,33 @@
+from setuptools import setup, find_packages
+import os
+
+version = '1.0'
+
+setup(name='quintagroup.portlet.cumulus',
+      version=version,
+      description="A tag cloud portlet that rotates tags in 3D using a Flash movie",
+      long_description=open("README.txt").read() + "\n" +
+                       open(os.path.join("docs", "HISTORY.txt")).read(),
+      # Get more strings from http://www.python.org/pypi?%3Aaction=list_classifiers
+      classifiers=[
+        "Framework :: Plone",
+        "Programming Language :: Python",
+        "Topic :: Software Development :: Libraries :: Python Modules",
+        ],
+      keywords='plone portlet flash tag cloud',
+      author='Bohdan Koval',
+      author_email='koval@quintagroup.com',
+      url='http://svn.quintagroup.com/products/quintagroup.portlet.cumulus',
+      license='GPL',
+      packages=find_packages(exclude=['ez_setup']),
+      namespace_packages=['quintagroup', 'quintagroup.portlet'],
+      include_package_data=True,
+      zip_safe=False,
+      install_requires=[
+          'setuptools',
+          # -*- Extra requirements: -*-
+      ],
+      entry_points="""
+      # -*- Entry points: -*-
+      """,
+      )
